//#pragma once
#ifndef CH_GRAHAM_JARVIS
#define CH_GRAHAM_JARVIS


#include <vector>   // the std vector
#include "drawareawidget.h" // just for Point_2 definition

CGAL_BEGIN_NAMESPACE


// entry point for Graham's alg. implementation
template <class ForwardIterator, class OutputIterator, class Traits> 
OutputIterator 
ch_my_graham( ForwardIterator first, 
	 	      ForwardIterator last, 
		      OutputIterator result, 
		      const Traits& ch_traits )
{

	if( first == last ) return result;             // nothing in the input (no points to process)
	typedef typename Traits::Point_2 Point_2;

	OutputIterator res( result );  

	// compute size of the input point set
	CGAL_ch_assertion_code( \
		long int count_points = 0 );
	CGAL_ch_assertion_code( \
		for( ForwardIterator fit = first; fit != last; ++fit ) ++count_points; )
	long int points_size = last -first;  // OK for vector, O(n) for list


	//--- WRITE YOUR CODE HERE

	return res;  //  used for t>=6 - safety stop
}

// entry point for Graham's alg. implementation
template <class ForwardIterator, class OutputIterator, class Traits> 
OutputIterator 
ch_my_jarvis( ForwardIterator first, 
	 	      ForwardIterator last, 
		      OutputIterator result, 
		      const Traits& ch_traits )
{

	if( first == last ) return result;             // nothing in the input (no points to process)
	typedef typename Traits::Point_2 Point_2;

	OutputIterator res( result );  

	// compute size of the input point set
	CGAL_ch_assertion_code( \
		long int count_points = 0 );
	CGAL_ch_assertion_code( \
		for( ForwardIterator fit = first; fit != last; ++fit ) ++count_points; )
	long int points_size = last -first;  // OK for vector, O(n) for list


	//--- WRITE YOUR CODE HERE

	return res;  //  used for t>=6 - safety stop
}
//--- WRITE YOUR CODE HERE


CGAL_END_NAMESPACE

#endif // CH_GRAHAM_JARVIS
